﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.Globalization;
using System.Text.RegularExpressions;

namespace MoyariClient
{

   // public static String moge;
    public class AppCommon
    {
        public const String APPNAME = "MoyariClient";
        public const String APPVER = "0.09.910";
        public const String RELEASE_NOTE =
@"ver.0.09.910
・共有ファイル更新時、権限のないディレクトリがあっても中断しないように修正
ver.0.09.900
・接続時に繋ぐチャンネルで自分の共有数がずっと0のままの問題に対応
・チャンネルからユーザ情報を開いた時、チャンネルリストの共有数を更新するように修正
・ダウンロード結果をダブルクリックして対象ファイルを開く用に修正
ver.0.09.800
・wmvがダウンロードできないバグに対応
ver.0.09.700
・転送状況ウィンドウ右クリックメニューにユーザ情報とファイル一覧を追加
ver.0.09.600
・URL履歴、呼出履歴機能追加
・検索結果絞込み機能を拡張
　（サイズだけで一致判定、検索除外リスト）
・検索結果のファイル出力機能追加
・チャット画面右クリックからファイル検索機能追加
ver.0.09.500
・呼び出し小窓開く時にwav再生する機能追加
ver.0.09.400
・前回検索結果を消してないバグを修正
・特定メッセージ受信時に解析不能で落ちるバグを修正
・例外dump時にメインスレッドをロックしないように修正
ver.0.09.300
・httpdが不慮の落ち方した際に再開するように変更
・不正メッセージ受信時にdumpを作成
ver.0.09.200
・共有ファイル一覧の差し替え判定を高速化
・フォント・色変更時にメッセージ出すように変更
・アセンブリ名・アイコン修正
・起動接続時の共有ファイル一覧を差し替えコマンドで送っていたバグ修正
・受信メッセージ752(キューリクエストの戻り)を処理していなかったバグ修正
・設定変更時、ダウンロードフォルダのみ変更しても共有リストを更新していなかったバグ修正
・サーバ設定削除時にタブを削除していなかったバグ修正
ver.0.09.100
・メインウィンドウのレイアウト調整
ver.0.09.000
・無視リスト
・2G越えファイル対応
・検索窓最小化時に新規窓が行方不明になるバグ修正
・自動フォントスケールを無効
ver.0.08.100
・設定ちょっと修正
ver.0.08.000
・タイムアウトリトライ
・自動リモートキュー
ver.0.07.000
・ユーザブラウズ
・検索拡張
ver.0.06.000
・検索と転送
ver.0.05.000
バグ修正
・鯖未登録でユーザリストヘッダ触ると落ちる
追加変更
・簡易httpd用css設定
・簡易httpdログ中のリンクをaタグに変換
ver.0.04.000
バグ修正
・httpd機能で入室/退室メッセージが重複していた
追加変更
・ユーザリストにソート機能
・ウィンドウ半透明機能
ver.0.03.001
バグ修正
・文字サイズ中で起動するとレイアウトが崩れる
・httpd機能のユーザ名が１文字だと認証が通らない
ver.0.03.000
バグ修正
・アイコン設定
・html画面の多重送信を抑止
・鯖側から切断された場合にチャットパネルが変になる
・フォントウィンドウを開く時に現在値が反映されない
・ログ出力が相対パス強制になってる
・htlm表示用にサニタイズされていない
・設定ダイアログをリサイズ不可に
追加変更
・デフォルトフォントをMSゴシック12ptに
・チャンネルツリーでダブルクリックで入室できるように
・複数行貼り付け時に複数行貼り付け画面を表示
・「常に前面表示」機能を追加
・呼び出し小窓機能を追加
ver.0.02.000
・公開版
ver.0.01.000
初版

";            

        public const String SETTING_FILE = "setting.xml";
        public const String RESUME_FILE = "resume.xml";
        public const String EXCLUDE_FILE = "excludelist.xml";

        public static SettingInfo setting;
        public static ExcludeFileList excludeFileList = new ExcludeFileList();

        private static int serverIndexCounter = 0;
        private static int channelIndexCounter = 0;
        private static int userIndexCounter = 0;

        public const int KEEP_ALIVE_INTERVAL = 60000;
        public const int DEFAULT_HTTPD_PORT = 8001;

        public const String ERROR_CHARS = "\\/:*?\"<>| ";
        public static Encoding ENC_SJIS = Encoding.GetEncoding("Shift_JIS");
        public const int PANEL_LOG_DOROP_LIMIT = 10000;
        public const int PANEL_LOG_DOROP_STEP = 1000;

        public const int HTTP_LOGSTORE_MAX = 1000;
        public const String HTTP_LOGSTORE_KEY_CHANNNEL = "HTTP_LOGSTORE_KEY_CHANNNEL";

        public static Font defaultFont = new Font("ＭＳ ゴシック", 12);

        public const int DEFAULT_SHARE_PORT = 6689;
        public const int DEFAULT_MAX_DL = 4;
        public const int DEFAULT_MAX_UL = 4;
        public const int DEFAULT_MAX_DL_ATUSER = 2;
        public const int DEFAULT_MAX_UL_ATUSER = 2;
        public const String FILE_SITE_FOMMAT = "###,###,###,##0";

        // ダウンロード関係
        //public const int SOCKET_TIMEOUT = 60000; // 60sec
        public const int DEFAULT_SOCK_TIMEOUT_SEC = 60;
        public const int DEFAULT_REQUEST_TIMEOUT_SEC = 120;
        public const int SEC_TO_MILLSEC_RATE = 1000;
        public const int DL_BUFFER_SIZE = 1024 * 200;
        public const int DL_REFLESH_RATE_NS = 10000000; // = 1sec
        public const int SEARCH_REFLESH_RATE_MS = 300; // = 0.3sec
        public static int SEARCH_REFLESH_RATE_NS = SEARCH_REFLESH_RATE_MS * 10000;
        public const int SEARCH_TIMEOUT_NS = 15 * 10000000;// 15sec
        public const int SEARCH_TIMEOUT_WATCH_MS = 5 * 1000; // 5sec
        public const int SEARCH_FILTER_REFLESH_STEP = 500;

        public const int DL_SPAN_SLEEP = 3000;// 3sec
        public const int DL_AUTO_RETRY_SLEEP = 120;// 2min
        public const String DUMMY_MD5 = "00000000000000000000000000000000";
        public const int DOWNLOAD_START_BYTE = 0x31;
        public static byte[] DOWNLOAD_GET_BYTES = AppCommon.ENC_SJIS.GetBytes("GET");
        public static byte[] DOWNLOAD_SEND_BYTES = AppCommon.ENC_SJIS.GetBytes("SEND");
        public const int UL_BUFFER_SIZE = 1024 * 200;
        public const String UL_QUEUE_MSG = "//WantQueue";
        public const String DL_WORK_FILE_EXP = ".download";

        public const String URL_PATTERN = @"s?https?://[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+";

       // public static bool disableDebugProtcol = false;

        public static String getNextServerIndex()
        {
            serverIndexCounter++;
            return serverIndexCounter.ToString();
        }

        public static String getNextChannelIndex()
        {
            channelIndexCounter++;
            return channelIndexCounter.ToString();
        }

        public static String getNextUserIndex()
        {
            userIndexCounter++;
            return userIndexCounter.ToString();
        }
        
        //読み込み
        public static void load()
        {
            try
            {
                String filePath = Application.StartupPath + "\\" + SETTING_FILE;
                if (File.Exists(filePath))
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(SettingInfo));
                    FileStream fs = new FileStream(filePath, FileMode.Open);
                    setting = (SettingInfo)serializer.Deserialize(fs);
                    fs.Close(); 

                    //設定値のサニタイズ
                    safingSettings();

                    Console.WriteLine(DateTime.Now + "設定ロードok");
                }

            }
            catch (Exception e)
            {
                MessageBox.Show("設定読み込みに失敗しました：" + e.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);                
            }

            if (setting == null)
            {
                // インスタンスだけ作る
                setting = new SettingInfo();

                // 設定無し起動時は展開
                setting.colorNormalMsgHtml = ColorTranslator.ToHtml(setting.colorInfo.colorNormalMsg);
                setting.colorBackgroundHtml = ColorTranslator.ToHtml(setting.colorInfo.colorBackground);
                setting.colorTimeHtml = ColorTranslator.ToHtml(setting.colorInfo.colorTime);
                setting.colorNickHtml = ColorTranslator.ToHtml(setting.colorInfo.colorNick);
                setting.colorSysMsgHtml = ColorTranslator.ToHtml(setting.colorInfo.colorSysMsg);
                setting.colorJoinMsgHtml = ColorTranslator.ToHtml(setting.colorInfo.colorJoinMsg);
                setting.colorPartMsgHtml = ColorTranslator.ToHtml(setting.colorInfo.colorPartMsg);
                setting.colorFocusChBackHtml = ColorTranslator.ToHtml(setting.colorInfo.colorFocusChBack);
                setting.colorFocusChForeHtml = ColorTranslator.ToHtml(setting.colorInfo.colorFocusChFore);
            }
            else
            {
                //Colorのインスタンス化
                try{
                    setting.colorInfo.colorNormalMsg = ColorTranslator.FromHtml(setting.colorNormalMsgHtml);
                    setting.colorInfo.colorBackground = ColorTranslator.FromHtml(setting.colorBackgroundHtml);
                    setting.colorInfo.colorTime = ColorTranslator.FromHtml(setting.colorTimeHtml);
                    setting.colorInfo.colorNick = ColorTranslator.FromHtml(setting.colorNickHtml);
                    setting.colorInfo.colorSysMsg = ColorTranslator.FromHtml(setting.colorSysMsgHtml);
                    setting.colorInfo.colorJoinMsg = ColorTranslator.FromHtml(setting.colorJoinMsgHtml);
                    setting.colorInfo.colorPartMsg = ColorTranslator.FromHtml(setting.colorPartMsgHtml);
                    setting.colorInfo.colorFocusChBack = ColorTranslator.FromHtml(setting.colorFocusChBackHtml);
                    setting.colorInfo.colorFocusChFore = ColorTranslator.FromHtml(setting.colorFocusChForeHtml);
                }
                catch (Exception e)
                {
                    MessageBox.Show("色設定の読み込みに失敗しました：" + e.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }

            //フォント初期化
            try
            {
                setting.txtFont = new Font(setting.fontName, setting.fontSize);
            }
            catch (Exception e)
            {
                Console.WriteLine("フォントの初期化に失敗：[" + setting.fontName + "](" + setting.fontSize + ")　" + e.Message);
                setting.txtFont = defaultFont;
            }
                        
            // リジューム情報ロード
            DownloadManager.initResumeInfo();

            // 共有リスト初回情報ロード
            if (AppCommon.setting.enableShare)
            {
                UploadManager.initSharedFileInfo();

                UploadManager.startUploadServer();
            }

            // 除外リストロード
            try
            {
                if (File.Exists(EXCLUDE_FILE))
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(ExcludeFileList));
                    FileStream fs = new FileStream(EXCLUDE_FILE, FileMode.Open);
                    excludeFileList = (ExcludeFileList)serializer.Deserialize(fs);
                    fs.Close();
                }
            }
            catch (Exception e)
            {
                //初期化はMsgBox
                MessageBox.Show("除外ファイルリスト読み込みに失敗しました：" + e.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private static void safingSettings()
        {
            //indexをリセット
            foreach (ServerInfo info in setting.infos)
            {
                info.index = getNextServerIndex();

                //禁則文字を潰す
                info.name = toSafeStr(info.name);
                info.user = toSafeStr(info.user);
            }

            // sanitize
            Rectangle rec = Screen.PrimaryScreen.Bounds;
            int widthMax = rec.Width - 100;
            int heightMax = rec.Height - 100;
            sanitNum(ref setting.windowPosX, 0, widthMax, 0);
            sanitNum(ref setting.windowPosY, 0, heightMax, 0);
            sanitNum(ref setting.windowWidth, 1, widthMax, 620);
            sanitNum(ref setting.windowHeight, 1, heightMax, 300);
            sanitNum(ref setting.fontSize, 0, 100, (int)AppCommon.defaultFont.Size);
            sanitNum(ref setting.httpdPort, 0, 65535, AppCommon.DEFAULT_HTTPD_PORT);
            sanitNum(ref setting.transVolume, 0, 100, 100);
            sanitNum(ref setting.shareWaitPort, 0, 65535, AppCommon.DEFAULT_SHARE_PORT);
            sanitNum(ref setting.searchWindowPosX, 0, widthMax, 0);
            sanitNum(ref setting.searchWindowPosY, 0, heightMax, 0);
            sanitNum(ref setting.searchWindowWidth, 1, widthMax, 620);
            sanitNum(ref setting.searchWindowHeight, 1, heightMax, 300);
            sanitNum(ref setting.searchListColWidthFname, 1, widthMax, 280);
            sanitNum(ref setting.searchListColWidthBytes, 1, widthMax, 100);
            sanitNum(ref setting.searchListColWidthUser, 1, widthMax, 100);
            sanitNum(ref setting.searchListColWidthSpeed, 1, widthMax, 50);
            sanitNum(ref setting.searchListColWidthServer, 1, widthMax, 70);
            sanitNum(ref setting.transWindowPosX, 1, widthMax, 0);
            sanitNum(ref setting.transWindowPosY, 1, heightMax, 0);
            sanitNum(ref setting.transWindowWidth, 1, widthMax, 620);
            sanitNum(ref setting.transWindowHeight, 1, heightMax, 300);
            sanitNum(ref setting.dlListColWidthdlFile, 1, widthMax, 200);
            sanitNum(ref setting.dlListColWidthdlUser, 1, widthMax, 80);
            sanitNum(ref setting.dlListColWidthdlSpeed, 1, widthMax, 50);
            sanitNum(ref setting.dlListColWidthdlBytes, 1, widthMax, 100);
            sanitNum(ref setting.dlListColWidthdlks, 1, widthMax, 60);
            sanitNum(ref setting.dlListColWidthdlStatus, 1, widthMax, 100);
            sanitNum(ref setting.ulListColWidthulFile, 1, widthMax, 280);
            sanitNum(ref setting.ulListColWidthulUser, 1, widthMax, 100);
            sanitNum(ref setting.ulListColWidthulSpeed, 1, widthMax, 50);
            sanitNum(ref setting.ulListColWidthulBytes, 1, widthMax, 80);
            sanitNum(ref setting.ulListColWidthulks, 1, widthMax, 60);
            sanitNum(ref setting.ulListColWidthulStatus, 1, widthMax, 100);

            sanitNum(ref setting.sockTimeoutSec, 10, 1000, AppCommon.DEFAULT_SOCK_TIMEOUT_SEC);
            sanitNum(ref setting.maxDownloadNum, 1, 100, AppCommon.DEFAULT_MAX_DL);
            sanitNum(ref setting.maxUploadNum, 1, 100, AppCommon.DEFAULT_MAX_UL);
            sanitNum(ref setting.maxDownloadNumAtUser, 1, AppCommon.DEFAULT_MAX_DL_ATUSER, AppCommon.DEFAULT_MAX_DL_ATUSER);
            sanitNum(ref setting.maxUploadNumAtUser, 1, AppCommon.DEFAULT_MAX_UL_ATUSER, AppCommon.DEFAULT_MAX_UL_ATUSER);

            // 配列
            if (setting.infos == null)
            {
                setting.infos = new ServerInfo[0];
            }
            if (setting.appendKeywords == null)
            {
                setting.appendKeywords = new String[0];
            }
            if (setting.shareFolderList == null)
            {
                setting.shareFolderList = new String[0];
            }
            if (setting.ignoreList == null)
            {
                setting.ignoreList = new List<String>();
            }
        }

        public static void sanitNum(ref int target, int min, int max, int def)
        {
            if (target < min || target > max)
            {
                target = def;                
            }
        }

        // 保存
        public static void save()
        {
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(SettingInfo));
                FileStream fs = new FileStream(Application.StartupPath + "\\" + SETTING_FILE, FileMode.Create);
                serializer.Serialize(fs, setting);
                fs.Close();
            }
            catch (Exception e)
            {
                MessageBox.Show("設定保存に失敗しました：" + e.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }

        // 除外ファイルの追加
        public static void addExcludeFiles(Form owner, List<String> fileNames)
        {
            bool createFlg = (excludeFileList.fileNames.Count == 0);
            excludeFileList.fileNames.AddRange(fileNames);
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(ExcludeFileList));
                FileStream fs = new FileStream(EXCLUDE_FILE, FileMode.Create);
                serializer.Serialize(fs, excludeFileList);
                fs.Close();

                if (createFlg)
                {
                    MessageBox.Show(owner, "除外ファイルリストを作成しました\n初期化する場合 " + EXCLUDE_FILE + " を削除して下さい", "", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch (Exception e)
            {
                MessageBox.Show(owner, "除外ファイルリスト保存に失敗しました：" + e.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

        }

        private static String toSafeStr(String str)
        {
            char[] errChars = AppCommon.ERROR_CHARS.ToCharArray();
            foreach (char c in errChars)
            {
                if (str.IndexOf(c) > 0)
                {
                    str = str.Replace(c.ToString(), "");
                }
            }
            return str;
        }

        public static String getDownloadDirWithSceparator()
        {
            String tmpDirPath = setting.downloadFolder;
            if (tmpDirPath.EndsWith("\\") == false && tmpDirPath.EndsWith("/") == false)
            {
                tmpDirPath += Path.DirectorySeparatorChar;
            }
            return tmpDirPath;
        }

        public static String code2LinkType(String code)
        {
            switch (code)
            {
                case "1":
                    return "14.4k";
                case "2":
                    return "28.8k";
                case "3":
                    return "33.6k";
                case "4":
                    return "56.7k";
                case "5":
                    return "64k";
                case "6":
                    return "128k";
                case "7":
                    return "Cable";
                case "8":
                    return "DSL";
                case "9":
                    return "T1";
                case "10":
                    return "T3+";
                default:
                    return "unknown";
            }
        }

        public static String filePath2FileName(String path)
        {
            int idx = path.LastIndexOf("\\");
            if (idx < 0)
            {
                idx = path.LastIndexOf("/");
                if (idx < 0)
                {
                    return path;
                }
            }
            return path.Substring(idx + 1);
        }

        private static Regex PATTERN_FILENAME1 = new Regex(@"^.*\([0-9]+\)\.[^\.\(\)]+$");
        private static Regex PATTERN_FILENAME2 = new Regex(@"^.*\([0-9]+\)$");
        public static String nextFileName(String fileName)
        {
            int idx = fileName.LastIndexOf(".");
            if (idx > 0)
            {
                if (PATTERN_FILENAME1.IsMatch(fileName))
                {
                    //番号inc
                    return procIncPattern(fileName);
                }
                else
                {
                    //(1)付与
                    return fileName.Substring(0, idx) + "(1)" + fileName.Substring(idx);
                }
            }
            else
            {
                if (PATTERN_FILENAME2.IsMatch(fileName))
                {
                    //番号inc
                    return procIncPattern(fileName);
                }
                else
                {
                    //(1)付与
                    return fileName + "(1)";
                }
            }
        }
        private static String procIncPattern(String fileName)
        {
            int lidx = fileName.LastIndexOf("(");
            int ridx = fileName.LastIndexOf(")");

            String lpart = fileName.Substring(0, lidx+1);
            String mid = fileName.Substring(lidx + 1, (ridx - lidx)-1);
            String rpart = fileName.Substring(ridx);

            int num = int.Parse(mid) + 1;
            return lpart + num + rpart;
        }
        
        public static String[] splitMessageToString(String message, int listPadding)
        {
            List<String> tmpStrList = new List<String>();

            while (message.Length > 0)
            {
                if ('\"' == message[0])
                {
                    int idx = message.IndexOf('\"', 1);
                    if (idx > 1)
                    {
                        String p1 = message.Substring(0, idx + 1);
                        message = message.Substring(idx + 1);
                        if (message.Length > 0 && ' ' == message[0])
                        {
                            message = message.Substring(1);
                        }
                        tmpStrList.Add(p1.Replace("\"", ""));
                    }
                    else
                    {
                        Console.WriteLine("★ splitMessageToString 不正メッセージ1[" + message + "]");
                        tmpStrList.Add(message);
                        message = "";
                    }
                }
                else
                {
                    int idx = message.IndexOf(" ");
                    if (idx > 0)
                    {
                        String p1 = message.Substring(0, message.IndexOf(" "));
                        tmpStrList.Add(p1.Replace("\"", ""));
                        message = message.Substring(idx + 1);
                    }
                    else
                    {
                        tmpStrList.Add(message);
                        message = "";
                    }
                }
            }

            while (tmpStrList.Count < listPadding)
            {
                tmpStrList.Add("");
            }

            String[] result = tmpStrList.ToArray();

            return result;
        }

        public static String ipStr2hostStr(String ipStr)
        {
            long ipNum = long.Parse(ipStr);
            byte[] ipBa = BitConverter.GetBytes(ipNum);
            return (int)ipBa[0] + "." + (int)ipBa[1] + "." + (int)ipBa[2] + "." + (int)ipBa[3];
        }

        private static Object logDumpLock = new Object();
        public static void dumpException(Exception e, String msg = null)
        {
            lock (logDumpLock)
            {
                using (StreamWriter w = new StreamWriter("dump.log", true, ENC_SJIS))
                {
                    Console.WriteLine("▼▼▼dumpException▼▼▼");
                    String timeStr = DateTime.Now.ToString("yyyyMMdd HH:mm:ss");
                    Console.WriteLine(timeStr);
                    w.WriteLine(timeStr);
                    if (msg != null)
                    {
                        Console.WriteLine(msg);
                        w.WriteLine(msg);
                    }
                    Console.WriteLine(e.Message);
                    w.WriteLine(e.Message);
                    Console.WriteLine(e.StackTrace);
                    w.WriteLine(e.StackTrace);
                    w.Close();
                    Console.WriteLine("▲▲▲dumpException▲▲▲");
                }
            }
        }
    }

    // ListViewSorter
    public class ListViewColumnSorter : IComparer
    {
        /// ソート対象列
        protected int _columnToSort;
        /// ソートオーダー
        protected SortOrder _orderOfSort;
        /// 比較オブジェクト
        protected CaseInsensitiveComparer _objectCompare;
        /// ソート対象列
        public int SortColumn
        {
            get { return _columnToSort; }
            set { _columnToSort = value; }
        }
        /// ソートオーダー
        public SortOrder Order
        {
            get { return _orderOfSort; }
            set { _orderOfSort = value; }
        }
        /// コンストラクタ
        public ListViewColumnSorter()
        {
            _orderOfSort = SortOrder.None;
            _objectCompare = new CaseInsensitiveComparer(CultureInfo.CurrentUICulture);
            this.Order = SortOrder.Ascending;
        }
        /// IComparerインターフェース実装
        public int Compare(object x, object y)
        {
            
            ListViewItem listViewX = x as ListViewItem;
            ListViewItem listViewY = y as ListViewItem;

            int result = compareColumn(listViewX, listViewY);

            //result = _objectCompare.Compare(
            //  listViewX.SubItems[_columnToSort].Text, listViewY.SubItems[_columnToSort].Text);
            
            if (_orderOfSort == SortOrder.Ascending)
            {
                return result;
            }
            else if (_orderOfSort == SortOrder.Descending)
            {
                return (-result);
            }
            else
            {
                return 0;
            }
        }

        protected virtual int compareColumn(ListViewItem listViewX, ListViewItem listViewY)
        {
            return _objectCompare.Compare(
              listViewX.SubItems[_columnToSort].Text, listViewY.SubItems[_columnToSort].Text);
        }
    }

    public class SettingInfo
    {
        public bool topMost = false;
        public bool taskTray = false;
        public bool enableLog = false;
        public bool autoRetry = false;
        public bool saveWindowPos = false;
        public int windowPosX = 0;
        public int windowPosY = 0;
        public int windowWidth = 0;
        public int windowHeight = 0;
        public String logDir = "log";
        public String fontName = AppCommon.defaultFont.Name;
        public int fontSize = (int)AppCommon.defaultFont.Size;
        public String colorNormalMsgHtml;
        public String colorBackgroundHtml;
        public String colorTimeHtml;
        public String colorNickHtml;
        public String colorSysMsgHtml;
        public String colorJoinMsgHtml;
        public String colorPartMsgHtml;
        public String colorFocusChBackHtml;
        public String colorFocusChForeHtml;
        public bool httpdEnabled = false;
        public int httpdPort = AppCommon.DEFAULT_HTTPD_PORT;
        public String httpdUserName = "";
        public String httpdPassword = "";
        public bool httpdViewPort = false;
        public String httpdViewPortValue = "width=320";
        public String httpdUpperFrameSize = "40";
        public ServerInfo[] infos = new ServerInfo[0];
        public bool enableCalling = true;
        public bool callByNick = true;
        public String callingSoundFilePath = "";
        public String[] appendKeywords = new String[0];
        public bool enableTrans = true;
        public int transVolume = 100;
        public List<String> ignoreList = new List<String>();
        public int historySizeCall = 3;
        public int historySizeURL = 4;
        public int historyTextShowLimit = 100;

        public bool enableShare = false;
        public String linktype = "0";
        public int shareWaitPort = AppCommon.DEFAULT_SHARE_PORT;
        public String downloadFolder = "download";
        public bool enableSubFolder = false;
        public String[] shareFolderList = new String[0];

        public int searchWindowPosX = 0;
        public int searchWindowPosY = 0;
        public int searchWindowWidth = 0;
        public int searchWindowHeight = 0;
        public int searchListColWidthFname = 0;
        public int searchListColWidthBytes = 0;
        public int searchListColWidthUser = 0;
        public int searchListColWidthSpeed = 0;
        public int searchListColWidthServer = 0;

        public int transWindowPosX = 0;
        public int transWindowPosY = 0;
        public int transWindowWidth = 0;
        public int transWindowHeight = 0;
        public int dlListColWidthdlFile = 0;
        public int dlListColWidthdlUser = 0;
        public int dlListColWidthdlSpeed = 0;
        public int dlListColWidthdlBytes = 0;
        public int dlListColWidthdlks = 0;
        public int dlListColWidthdlStatus = 0;
        public int ulListColWidthulFile = 0;
        public int ulListColWidthulUser = 0;
        public int ulListColWidthulSpeed = 0;
        public int ulListColWidthulBytes = 0;
        public int ulListColWidthulks = 0;
        public int ulListColWidthulStatus = 0;

        public int sockTimeoutSec = AppCommon.DEFAULT_SOCK_TIMEOUT_SEC;
        public int requestTimeoutSec = AppCommon.DEFAULT_REQUEST_TIMEOUT_SEC;
        public bool timeout2retry = true;
        public bool remoteQueueAuto = true;
        public int maxDownloadNum = AppCommon.DEFAULT_MAX_DL;  
        public int maxUploadNum = AppCommon.DEFAULT_MAX_UL;    
        public int maxDownloadNumAtUser = AppCommon.DEFAULT_MAX_DL_ATUSER;  
        public int maxUploadNumAtUser = AppCommon.DEFAULT_MAX_UL_ATUSER;

        public bool lastFilterWithoutSharedFile = true;
        public bool lastFilterWithoutSharedOnlySize = false;
        public bool lastFilterEnableDisregardList = true;

        [XmlIgnoreAttribute]
        public Font txtFont = null;
        [XmlIgnoreAttribute]
        public ColorSetting colorInfo = new ColorSetting();

        public bool disableDebugProtocol = false;
    }

    public class ServerInfo
    {
        [XmlIgnoreAttribute]
        public String index = "";
        public bool connectOnStart = false;
        public String name = "";
        public String host = "";
        public int port = 0;
        public String user = "";
        public String pass = "";
        public String[] channels = new String[0];
        [XmlIgnoreAttribute]
        public bool reconnectControlFlg = true; //再接続制御フラグ
        [XmlIgnoreAttribute]
        public String reconnectReserveKey = null;
        [XmlIgnoreAttribute]
        public DateTime reconnectLastTime = DateTime.Now;

        public ServerInfo()
        {
            index = AppCommon.getNextServerIndex();
        }
    }

    public class ExcludeFileList
    {
        public List<String> fileNames = new List<String>();
    }

    public class ColorSetting
    {
        public static Color SET1colorNormalMsg = Color.FromArgb(0xFF, 0x00, 0x00, 0x00);
        public static Color SET1colorBackground = Color.FromArgb(0xFF, 0xFF, 0xFF, 0xFF);
        public static Color SET1colorTime = Color.FromArgb(0xFF, 0x00, 0xAA, 0x00);
        public static Color SET1colorNick = Color.FromArgb(0xFF, 0x00, 0x00, 0xAA);
        public static Color SET1colorSysMsg = Color.FromArgb(0xFF, 0xAA, 0x00, 0xAA);
        public static Color SET1colorJoinMsg = Color.FromArgb(0xFF, 0x66, 0x66, 0x66);
        public static Color SET1colorPartMsg = Color.FromArgb(0xFF, 0x33, 0x33, 0x33);
        public static Color SET1colorFocusChBack = Color.FromArgb(0xFF, 0x0A, 0x24, 0x6A);
        public static Color SET1colorFocusChFore = Color.FromArgb(0xFF, 0xFF, 0xFF, 0xFF);

        public static Color SET2colorNormalMsg = ColorTranslator.FromHtml("#FFFFFF");
        public static Color SET2colorBackground = ColorTranslator.FromHtml("#004040");
        public static Color SET2colorTime = ColorTranslator.FromHtml("#00FFFF");
        public static Color SET2colorNick = ColorTranslator.FromHtml("#FFFF00");
        public static Color SET2colorSysMsg = ColorTranslator.FromHtml("#FF0000");
        public static Color SET2colorJoinMsg = ColorTranslator.FromHtml("#00FF00");
        public static Color SET2colorPartMsg = ColorTranslator.FromHtml("#FF00FF");
        public static Color SET2colorFocusChBack = Color.FromArgb(0xFF, 0x0A, 0x24, 0x6A);
        public static Color SET2colorFocusChFore = Color.FromArgb(0xFF, 0xFF, 0xFF, 0xFF);

        public Color colorNormalMsg = SET2colorNormalMsg;
        public Color colorBackground = SET2colorBackground;
        public Color colorTime = SET2colorTime;
        public Color colorNick = SET2colorNick;
        public Color colorSysMsg = SET2colorSysMsg;
        public Color colorJoinMsg = SET2colorJoinMsg;
        public Color colorPartMsg = SET2colorPartMsg;
        public Color colorFocusChBack = SET2colorFocusChBack;
        public Color colorFocusChFore = SET2colorFocusChFore;

        public Color colorTaskReady = ColorTranslator.FromHtml("#FFFF00");//黄
        public Color colorTaskActive = ColorTranslator.FromHtml("#00FF00");//緑
        public Color colorTaskComp = ColorTranslator.FromHtml("#9999FF");//青
        public Color colorTaskFail = ColorTranslator.FromHtml("#FF3333");//茶色
    }

    //保存しない。接続時情報
    public class ChannelInfo
    {
        public String index = "";
        public String name = null;
        public String userNum = "";
        public String topic = "";
        public bool joined = false;
        //public bool joinRequested = false;
        public bool isPrivateMsgCh = false;
        public List<UserInfo> userList = new List<UserInfo>();

        public ChannelInfo(String name)
        {
            this.name = name;
            this.index = AppCommon.getNextChannelIndex();
        }
    }

    //保存しない。接続時情報
    public class UserInfo
    {
        public String index = "";
        public String name = null;
        public String sharing = "";
        public String linktype = "";

        public UserInfo(String name, String sharing, String linktype)
        {
            this.name = name;
            this.sharing = sharing;
            this.linktype = AppCommon.code2LinkType(linktype);            
            this.index = AppCommon.getNextUserIndex();
        }

    }
    
}



//// ダミー
//static void dumpSetting()
//{
//    SettingInfo setting = new SettingInfo();
//    ServerInfo serv1 = new ServerInfo();
//    serv1.connectOnStart = true;
//    serv1.name = "さば１";
//    serv1.host = "host1.aaa.bbb";
//    serv1.port = 66554;
//    serv1.user = "username1";
//    serv1.pass = "pass1";
//    serv1.channels = new String[] { "#channel1", "#ちゃねる2" };
//    ServerInfo serv2 = new ServerInfo();
//    serv2.connectOnStart = true;
//    serv2.name = "さば２";
//    serv2.host = "host2.aaa.bbb";
//    serv2.port = 76554;
//    serv2.user = "username2";
//    serv2.pass = "pass2";
//    serv2.channels = new String[] { "#channelA", "#ちゃねるB" };

//    setting.enableLog = true;
//    setting.autoRetry = true;
//    setting.logDir = "log";
//    setting.infos = new ServerInfo[] { serv1, serv2 };

//    XmlSerializer serializer = new XmlSerializer(typeof(SettingInfo));
//    FileStream fs = new FileStream(Application.StartupPath + "\\" + SETTING_FILE, FileMode.Create);
//    serializer.Serialize(fs, setting);
//    fs.Close();
//}