﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;
using System.Media;

namespace MoyariClient
{
    public partial class FormCalling : Form
    {
        private static Object lockObj = new Object();
        private static FormCalling instance = null;
        public static void proc(MainForm parent, String timeStr, String pattern, String message1, String message2, int matchStartIdx)
        {
            lock (lockObj)
            {
                if (instance == null)
                {
                    instance = new FormCalling();                                   
                    parent.AddOwnedForm(instance);
                    instance.StartPosition = FormStartPosition.Manual;
                    instance.Location = new Point(parent.Location.X + (parent.Width - instance.Width) / 2, parent.Location.Y + (parent.Height - instance.Height) / 2);                    
                    instance.Show();
                }
                instance.appendMsg(timeStr, pattern, message1, message2, matchStartIdx);
                instance.TopMost = true;
                instance.TopMost = false;
            }            
        }

        // ------------------------------------------------

        public FormCalling()
        {
            InitializeComponent();

            textBoxCalling.Font = AppCommon.setting.txtFont;
            textBoxCalling.BackColor = AppCommon.setting.colorInfo.colorBackground;
        }

        // メッセージ追記
        private void appendMsg(String timeStr, String pattern, String message1, String message2, int matchStartIdx)
        {
            message2 += " ";
            String msg2_1 = message2.Substring(0, matchStartIdx);
            String msg2_2 = message2.Substring(matchStartIdx, pattern.Length);
            int len = matchStartIdx + pattern.Length;
            String msg2_3 = message2.Substring(len, message2.Length - len - 1);
            
            int lockStartPos = textBoxCalling.Text.Length;
            textBoxCalling.SelectionStart = lockStartPos;
            textBoxCalling.SelectionColor = AppCommon.setting.colorInfo.colorTime;
            textBoxCalling.AppendText(timeStr);

            //nick
            textBoxCalling.SelectionColor = AppCommon.setting.colorInfo.colorNick;
            textBoxCalling.AppendText(message1 + " > ");
            //メッセージ
            textBoxCalling.SelectionColor = AppCommon.setting.colorInfo.colorNormalMsg;

            if (textBoxCalling.SelectionFont.Bold == false)
            {
                textBoxCalling.AppendText(msg2_1);
                textBoxCalling.SelectionFont = new Font(textBoxCalling.SelectionFont, FontStyle.Bold);
                textBoxCalling.AppendText(msg2_2);
                textBoxCalling.SelectionFont = new Font(textBoxCalling.SelectionFont, FontStyle.Regular);
                textBoxCalling.AppendText(msg2_3);
            }
            else
            {
                textBoxCalling.AppendText(msg2_1);
                textBoxCalling.AppendText(msg2_2);
                textBoxCalling.AppendText(msg2_3);
            }

            textBoxCalling.AppendText(System.Environment.NewLine);

            //ロック
            textBoxCalling.Select(lockStartPos, textBoxCalling.Text.Length);
            textBoxCalling.SelectionProtected = true;
                                    
            textBoxCalling.SelectionStart = textBoxCalling.Text.Length;
            textBoxCalling.ScrollToCaret();

            String waveFile = AppCommon.setting.callingSoundFilePath;
            if (waveFile != null && waveFile.Length > 1)
            {
                Task.Factory.StartNew(() =>
                {
                    try
                    {
                        SoundPlayer player = new SoundPlayer(waveFile);
                        player.PlaySync();
                        player.Dispose();
                    }catch(Exception e){
                        Console.WriteLine("呼び出し音再生でエラー " + e.Message);
                    }
                });
            }
        }

        // とじるとき
        private void FormCalling_FormClosing(object sender, FormClosingEventArgs e)
        {
            lock (lockObj)
            {
                instance = null;
            }
        }

    }
}
