﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;
using System.Threading;

namespace MoyariClient
{
    public partial class FormSearchBlock : Form
    {
        public bool alive = true;
        private int counter = 0;

        public FormSearchBlock()
        {
            InitializeComponent();
            counter = 0;
            pingThread();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("検索を中断しますか",
                "検索中断確認",
                MessageBoxButtons.YesNo,
                MessageBoxIcon.Exclamation,
                MessageBoxDefaultButton.Button2);

            if (result == DialogResult.Yes)
            {
                closeBlock(true);
            }
        }
        
        // とじる
        delegate void closeBlockDelegate(bool breakFlg);
        public void closeBlockInvoke(bool breakFlg)
        {
            if (alive)
            {
                this.Invoke(new closeBlockDelegate(closeBlock), new object[] { breakFlg });
            }
        }
        private void closeBlock(bool breakFlg)
        {
            alive = false;
            FormSearch.unlockProc(breakFlg);
            Close();
            this.Dispose();
        }

        delegate void updateTitleDelegate();
        public void updateTitleInvoke()
        {
            this.Invoke(new updateTitleDelegate(updateTitle), new object[] {  });
        }
        private void updateTitle()
        {
            if (alive)
            {
                counter += 1;
                if (counter > 7)
                {
                    counter = 1;
                }
                String ttl = "検索中";
                for (int i = 0; i < counter; i++)
                {
                    ttl += "．";
                }
                this.Text = ttl;
            }
        }

        private void pingThread(){
            Task.Factory.StartNew(() =>
            {
                try
                {
                    while (alive)
                    {
                        Thread.Sleep(AppCommon.SEARCH_REFLESH_RATE_MS);
                        updateTitleInvoke();
                    }
                }catch(Exception){
                }
            });
        }
    }
}
