﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MoyariClient
{
    public partial class FormSearchFilter : Form
    {

        //private FormSearch parent;
        public Action<String, bool, bool, bool> resultCall;

        public FormSearchFilter(Action<String, bool, bool, bool> resultCall, String filterWord, bool filterWithoutSharedFile, bool filterWithoutSharedOnlySize, bool filterEnableDisregardList)
        {
            InitializeComponent();
            this.resultCall = resultCall;
            textBoxFilterWord.Text = filterWord;
            checkBoxExcludeExist.Checked = filterWithoutSharedFile;
            checkBoxExcludeOnlySize.Checked = filterWithoutSharedOnlySize;
            checkBoxEnableDisregardList.Checked = filterEnableDisregardList;
            checkBoxExcludeOnlySize.Enabled = checkBoxExcludeExist.Checked;
        }
        
        // 所持ファイル除外チェック変更
        private void checkBoxExcludeExist_CheckedChanged(object sender, EventArgs e)
        {
            checkBoxExcludeOnlySize.Enabled = checkBoxExcludeExist.Checked;
        }

        // フィルタboxでEnter
        private void inputbox_keydown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.Enter)
            {
                okProc();
            }
        }

        // キャンセル
        private void buttonCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        // OK
        private void buttonOK_Click(object sender, EventArgs e)
        {
            okProc();
        }

        private void okProc()
        {
            //コールバック
            String filterWord = textBoxFilterWord.Text;
            bool filterWithoutSharedFile = checkBoxExcludeExist.Checked;
            bool filterWithoutSharedOnlySize = checkBoxExcludeOnlySize.Checked;
            bool filterEnableDisregardList = checkBoxEnableDisregardList.Checked;
            Close();
            this.resultCall(filterWord, filterWithoutSharedFile, filterWithoutSharedOnlySize, filterEnableDisregardList); 
        }

    }
}
