﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.VisualStyles;
using System.IO;
using System.Diagnostics;

namespace MoyariClient
{
    public partial class FormTransfer : Form
    {
        public const String COLNAME_DL1 = "File";
        public const String COLNAME_DL2 = "User";
        public const String COLNAME_DL3 = "Speed";
        public const String COLNAME_DL4 = "Bytes";
        public const String COLNAME_DL5 = "k/s";
        public const String COLNAME_DL6 = "Status";

        public const String COLNAME_UL1 = "File";
        public const String COLNAME_UL2 = "User";
        public const String COLNAME_UL3 = "Speed";
        public const String COLNAME_UL4 = "Bytes";
        public const String COLNAME_UL5 = "k/s";
        public const String COLNAME_UL6 = "Status";

        private static FormTransfer instance = null;        
        private static List<String> messageList = new List<String>();

        // ウィンドウ開くだけ
        public static void openAndReflesh()
        {
            if (instance == null)
            {
                //なければ作る
                instance = new FormTransfer();
                instance.Show();
            }
            else
            {
                //更新
                instance.refleshDownloadListInvoke(true);
            }
        }

        // インスタンスがあればtopに
        public static void windowToTop()
        {
            if (instance != null)
            {
                try
                {
                    instance.TopMost = true;
                    instance.TopMost = false;
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // インスタンスがあればDLタブをアクティブに
        public static void downloadTabActivate()
        {
            if (instance != null)
            {
                try
                {
                    instance.tabControl1.SelectedIndex = 0;
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        //// 閉じる
        //public static void closeALL()
        //{
        //    if (instance != null)
        //    {
        //        try
        //        {
        //            instance.Close();
        //        }
        //        catch (Exception e)
        //        {
        //            Console.WriteLine(e.Message + e.StackTrace);
        //        }
        //    }
        //}

        //tabControl1

        // DLタスクの初期化
        public static DownloadTaskInfo initDownLoadTask(ServerInfo serverInfo, SearchResult result)
        {
            openAndReflesh();

            DownloadTaskInfo task = new DownloadTaskInfo(serverInfo, result);

            String tmpDirPath = AppCommon.getDownloadDirWithSceparator();
            if (Directory.Exists(tmpDirPath) == false)
            {
                try
                {
                    Directory.CreateDirectory(tmpDirPath);
                }
                catch (Exception e)
                {
                    addConsoleMessage("ダウンロードフォルダ作成に失敗：" + e.Message);
                    Console.WriteLine(e.Message + e.StackTrace);
                    return null;
                }
            }

            //リジューム確認
            String resumeFilePath = null;
            ResumeTaskInfo[] resumeTasks =  DownloadManager.getResumeTaskInfoAry();
            foreach (ResumeTaskInfo rInfo in resumeTasks)
            {
                if (rInfo.srcFileName == result.filename && rInfo.srcFileSize == result.sizeNum)
                {
                    String checkWrkPath = tmpDirPath + rInfo.workFileName;
                    if (File.Exists(checkWrkPath))
                    {
                        //元ファイル名、元サイズが一致、workファイルがある
                        resumeFilePath = checkWrkPath;

                        FileInfo fi = new FileInfo(checkWrkPath);
                        task.resumeLength = fi.Length;
                        break;
                    }
                }
            }

            if (resumeFilePath != null) //既にリジュームキューが居る場合は取り消し
            {

                DownloadTaskInfo[] taskAry = DownloadManager.getTaskAry();
                foreach (DownloadTaskInfo chkq in taskAry)
                {
                    if (chkq.state != DownloadTaskState.CANCELED && chkq.state != DownloadTaskState.DEAD)
                    {
                        if (chkq.localWorkFilePath == resumeFilePath)
                        {
                            resumeFilePath = null;
                            break;
                        }
                    }
                }
            }

            if (resumeFilePath != null)
            {
                DialogResult ynRslt = MessageBox.Show(
                    "リジューム情報が見つかりました。\n"+
                    "このファイルをリジュームしますか？\n"+
                    result.filename,
                    "リジューム確認",
                    MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question,
                    MessageBoxDefaultButton.Button1);

                if (ynRslt == DialogResult.Yes)
                {
                    task.isResume = true;
                }
                else
                {
                    resumeFilePath = null;
                }
            }

            // リジュムできる場合
            if (task.isResume)
            {
                String tmpTruePath = tmpDirPath + task.searchResult.filename;
                while (checkDownloadFilePathExists(tmpTruePath, null))
                {
                    tmpTruePath = AppCommon.nextFileName(tmpTruePath);
                }
                task.localTrueFilePath = tmpTruePath;
                task.localTrueFileName = AppCommon.filePath2FileName(tmpTruePath);
                task.localWorkFilePath = resumeFilePath;
                task.localWorkFileName = AppCommon.filePath2FileName(resumeFilePath);
            }
            else
            {
                String tmpTruePath = tmpDirPath + task.searchResult.filename;
                String tmpWorkPath = tmpTruePath + AppCommon.DL_WORK_FILE_EXP;
                while (checkDownloadFilePathExists(tmpTruePath, tmpWorkPath))
                {
                    tmpTruePath = AppCommon.nextFileName(tmpTruePath);
                    tmpWorkPath = AppCommon.nextFileName(tmpWorkPath);
                }
                task.localTrueFilePath = tmpTruePath;
                task.localTrueFileName = AppCommon.filePath2FileName(tmpTruePath);
                task.localWorkFilePath = tmpWorkPath;
                task.localWorkFileName = AppCommon.filePath2FileName(tmpWorkPath);
            }

            task.state = DownloadTaskState.WAIT;
            return task;
        }

        // DLファイルパス既存チェック
        private static bool checkDownloadFilePathExists(String tmpTruePath, String tmpWorkPath)
        {
            if (File.Exists(tmpTruePath))
            {
                return true;
            }

            if (tmpWorkPath != null && File.Exists(tmpWorkPath))
            {
                return true;
            }

            //キューの中も見る
            DownloadTaskInfo[] taskAry = DownloadManager.getTaskAry();
            foreach (DownloadTaskInfo task in taskAry)
            {
                if (task.state == DownloadTaskState.CANCELED || task.state == DownloadTaskState.DEAD)
                {
                    continue;
                }
                if (task.localTrueFilePath == tmpTruePath)
                {
                    return true;
                }
                if (tmpWorkPath != null && task.localWorkFilePath == tmpWorkPath)
                {
                    return true;
                }
            }

            return false;
        }
        
        // コンソールメッセージ追加
        public static void addConsoleMessage(String msg)
        {
            Console.WriteLine("FormTransfer.addConsoleMessage:" + msg);
            messageList.Add(msg);
            if (messageList.Count > 100)
            {
                messageList.RemoveAt(0);
            }
            if (instance != null)
            {
                try
                {
                    instance.writeConsoleMessageInvoke(msg);
                }
                catch (Exception)
                {
                }
            }
        }

        // リストの描画更新：DL 全部
        public static void refleshDownloadListALL()
        {
            if (instance != null)
            {
                try
                {
                    instance.refleshDownloadListInvoke(false);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // リストの描画更新：DL 1個
        public static void refleshDownloadListViewItem(DownloadTaskInfo task)
        {
            if (instance != null)
            {
                try
                {
                    instance.releshDownloadItemInvoke(task);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // リストの描画更新：UL 全部
        public static void refleshUploadListALL()
        {
            if (instance != null)
            {
                try
                {
                    instance.refleshUploadListInvoke(false);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // リストの描画更新：UL 1個
        public static void refleshUploadListViewItem(UploadTaskInfo task)
        {
            if (instance != null)
            {
                try
                {
                    instance.releshUploadItemInvoke(task);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // 全タスク停止＆削除
        public static void stopALL()
        {
            DownloadManager.removeDownloadTasks(DownloadManager.getTaskAry(), false);
            UploadManager.removeUploadTasks(UploadManager.getTaskAry(), false);

            if (instance != null)
            {
                try
                {
                    instance.Close();
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message + e.StackTrace);
                }
            }
        }

        // ------------------------------------------------------
        private StringFormat consoleDrawFormat = new StringFormat(); //コンソール描画用
        private Brush textBrush = new SolidBrush(AppCommon.setting.colorInfo.colorNormalMsg); //コンソール描画用
        private Brush focusBrush = new SolidBrush(AppCommon.setting.colorInfo.colorFocusChBack); //プログレスバー描画用
        private Brush taskBrushReady = new SolidBrush(AppCommon.setting.colorInfo.colorTaskReady);
        private Brush taskBrushActive = new SolidBrush(AppCommon.setting.colorInfo.colorTaskActive);
        private Brush taskBrushComp = new SolidBrush(AppCommon.setting.colorInfo.colorTaskComp);
        private Brush taskBrushFail = new SolidBrush(AppCommon.setting.colorInfo.colorTaskFail); 

        private ListViewItem donwloadCtxViewItem = null; //右クリ時処理アイテム   
        private ListViewItem uploadCtxViewItem = null; //右クリ時処理アイテム   
        public static long lastActivateTime = 0;

        // コンストラクタ
        private FormTransfer()
        {
            if (AppCommon.setting.saveWindowPos)
            {
                this.StartPosition = FormStartPosition.Manual;
                this.Location = new Point(AppCommon.setting.transWindowPosX, AppCommon.setting.transWindowPosY);
            }

            InitializeComponent();

            if (AppCommon.setting.saveWindowPos)
            {
                this.Width = AppCommon.setting.transWindowWidth;
                this.Height = AppCommon.setting.transWindowHeight;

                foreach (ColumnHeader col in listViewUpload.Columns)
                {
                    switch (col.Text)
                    {
                        case COLNAME_UL1:
                            col.Width = AppCommon.setting.ulListColWidthulFile;
                            break;
                        case COLNAME_UL2:
                            col.Width = AppCommon.setting.ulListColWidthulUser;
                            break;
                        case COLNAME_UL3:
                            col.Width = AppCommon.setting.ulListColWidthulSpeed;
                            break;
                        case COLNAME_UL4:
                            col.Width = AppCommon.setting.ulListColWidthulBytes;
                            break;
                        case COLNAME_UL5:
                            col.Width = AppCommon.setting.ulListColWidthulks;
                            break;
                        case COLNAME_UL6:
                            col.Width = AppCommon.setting.ulListColWidthulStatus;
                            break;
                        default:
                            Console.WriteLine("不明なカラム：" + col.Text + "/" + col.Width + "");
                            break;
                    }
                }
                foreach (ColumnHeader col in listViewDownload.Columns)
                {
                    switch (col.Text)
                    {
                        case COLNAME_DL1:
                            col.Width = AppCommon.setting.dlListColWidthdlFile;
                            break;
                        case COLNAME_DL2:
                            col.Width = AppCommon.setting.dlListColWidthdlUser;
                            break;
                        case COLNAME_DL3:
                            col.Width = AppCommon.setting.dlListColWidthdlSpeed;
                            break;
                        case COLNAME_DL4:
                            col.Width = AppCommon.setting.dlListColWidthdlBytes;
                            break;
                        case COLNAME_DL5:
                            col.Width = AppCommon.setting.dlListColWidthdlks;
                            break;
                        case COLNAME_DL6:
                            col.Width = AppCommon.setting.dlListColWidthdlStatus;
                            break;
                        default:
                            Console.WriteLine("不明なカラム：" + col.Text + "/" + col.Width + "");
                            break;
                    }
                }
                foreach (ColumnHeader col in listViewUpload.Columns)
                {
                    switch (col.Text)
                    {
                        case COLNAME_UL1:
                            col.Width = AppCommon.setting.ulListColWidthulFile;
                            break;
                        case COLNAME_UL2:
                            col.Width = AppCommon.setting.ulListColWidthulUser;
                            break;
                        case COLNAME_UL3:
                            col.Width = AppCommon.setting.ulListColWidthulSpeed;
                            break;
                        case COLNAME_UL4:
                            col.Width = AppCommon.setting.ulListColWidthulBytes;
                            break;
                        case COLNAME_UL5:
                            col.Width = AppCommon.setting.ulListColWidthulks;
                            break;
                        case COLNAME_UL6:
                            col.Width = AppCommon.setting.ulListColWidthulStatus;
                            break;
                        default:
                            Console.WriteLine("不明なカラム：" + col.Text + "/" + col.Width + "");
                            break;
                    }
                }
            }
            
            listViewDownload.BackColor = AppCommon.setting.colorInfo.colorBackground;
            listViewDownload.ForeColor = AppCommon.setting.colorInfo.colorNormalMsg;            
            listViewUpload.BackColor = AppCommon.setting.colorInfo.colorBackground;
            listViewUpload.ForeColor = AppCommon.setting.colorInfo.colorNormalMsg;
            textBoxConsole.BackColor = AppCommon.setting.colorInfo.colorBackground;
            textBoxConsole.ForeColor = AppCommon.setting.colorInfo.colorNormalMsg;

            consoleDrawFormat.Alignment = StringAlignment.Near;
            consoleDrawFormat.FormatFlags = StringFormatFlags.NoWrap;
            consoleDrawFormat.Trimming = StringTrimming.Character;

            foreach (String msg in messageList)
            {
                writeConsoleMessage(msg);
            }
        }

        // 表示時
        private void FormTransfer_Shown(object sender, EventArgs e)
        {
            refleshDownloadList(false);
            refleshUploadList(false);
        }

        // アクティブイベント
        private void FormTransfer_Activated(object sender, EventArgs e)
        {
            lastActivateTime = DateTime.Now.ToFileTime();
        }

        // 閉じる時
        private void FormTransfer_FormClosing(object sender, FormClosingEventArgs e)
        {
            instance = null;
        }

        //DLリスト更新
        delegate void refleshDownloadListDelegate(bool toTopMost);
        public void refleshDownloadListInvoke(bool toTopMost)
        {
            if (InvokeRequired)
            {
                this.Invoke(new refleshDownloadListDelegate(refleshDownloadList), new object[] { toTopMost });
            }
            else
            {
                refleshDownloadList(toTopMost);
            }
        }
        private void refleshDownloadList(bool toTopMost)
        {
            listViewDownload.Items.Clear();
            DownloadTaskInfo[] taskAry = DownloadManager.getTaskAry();
            lock (taskAry)
            {
                foreach (DownloadTaskInfo task in taskAry)
                {
                    String[] line = { 
                              task.localTrueFileName, 
                              task.searchResult.nick +" [" + task.serverInfo.name + "]", 
                              task.searchResult.linktype, 
                              "", 
                              "",  
                              "" };
                    ListViewItem item = new ListViewItem(line);
                    item.Tag = task;
                    listViewDownload.Items.Add(item);
                    item.EnsureVisible();
                }
            }
            if (toTopMost)
            {
                this.TopMost = true;
                this.TopMost = false;
            }
        }

        // ダウンロードリストヘッダ描画
        private void listViewDownload_DrawColumnHeader(object sender, DrawListViewColumnHeaderEventArgs e)
        {
            e.DrawDefault = true;
        }

        // ダウンロードリスト描画
        private void listViewDownload_DrawSubItem(object sender, DrawListViewSubItemEventArgs e)
        {

            if ((e.ItemState & ListViewItemStates.Selected) == ListViewItemStates.Selected)
            {
                e.Graphics.FillRectangle(SystemBrushes.Highlight, e.Bounds);            
            }            

            ListViewItem item = (ListViewItem)e.Item;

            //item.
            DownloadTaskInfo task = (DownloadTaskInfo)item.Tag;
            Brush statusBrush = null;
            switch (task.state)
            {
                case DownloadTaskState.CANCELED:
                    statusBrush = taskBrushFail;
                    break;
                case DownloadTaskState.WAIT:
                    statusBrush = taskBrushReady;
                    break;
                case DownloadTaskState.REQUESTING:
                    statusBrush =  taskBrushReady;                    
                    break;
                case DownloadTaskState.DONWLOADING:
                    statusBrush = taskBrushActive;
                    break;
                case DownloadTaskState.COMPLETE:
                    statusBrush = taskBrushComp;
                    break;
                default: 
                    statusBrush = taskBrushFail;
                    break;
            }

            if (e.Header.Text == COLNAME_UL1)
            {
                e.Graphics.DrawString(task.localTrueFileName, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_DL2)
            {
                e.Graphics.DrawString(task.searchResult.nick + " [" + task.serverInfo.name + "]", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_DL3)
            {
                e.Graphics.DrawString(task.searchResult.linktype, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_DL4)
            {
                //DL量更新
                String byteTxt = task.completeSize.ToString(AppCommon.FILE_SITE_FOMMAT) + " of " + task.searchResult.sizeStr;
                e.Graphics.DrawString(byteTxt, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_DL5)
            {
                //速度更新
                if (task.dlSpeed != null)
                {
                    e.Graphics.DrawString(task.dlSpeed, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                }
            }
            else if (e.Header.Text == COLNAME_DL6)
            {
                switch (task.state)
                {
                    case DownloadTaskState.CANCELED:
                        e.Graphics.DrawString("キャンセルしました", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        break;
                    case DownloadTaskState.WAIT:
                        e.Graphics.DrawString("処理待ち", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);                        
                        break;
                    case DownloadTaskState.REQUESTING:
                        if (task.remoteQueueflg && task.remoteQueueSize != null)
                        {
                            e.Graphics.DrawString("リモートキュー[" + task.remoteQueueSize + "]", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        else if (task.autoRetryflg && task.autoRetrySleeping)
                        {
                            e.Graphics.DrawString("リトライ待機中(" + AppCommon.DL_AUTO_RETRY_SLEEP + "秒)", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        else
                        {
                            e.Graphics.DrawString("ダウンロード要求中", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                    case DownloadTaskState.DONWLOADING:
                        // プログレスバー             
                        int width = (int)(e.Bounds.Width * task.compPct);
                        Rectangle rect = new Rectangle(e.Bounds.X, e.Bounds.Y, width, e.Bounds.Height);
                        e.Graphics.FillRectangle(focusBrush, rect);
                        // 表記
                        if (task.compPctString != null)
                        {
                            e.Graphics.DrawString(task.compPctString, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                    case DownloadTaskState.COMPLETE:
                        e.Graphics.DrawString("完了", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        break;
                    default: //UNKNOWN
                        if (task.errorString != null)
                        {
                            e.Graphics.DrawString(task.errorString, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        else
                        {
                            e.Graphics.DrawString("不明なエラー", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                }
            }
            else
            {
                e.DrawText();                
            }
        }

        //ULリスト更新
        delegate void refleshUploadListDelegate(bool toTopMost);
        public void refleshUploadListInvoke(bool toTopMost)
        {
            if (InvokeRequired)
            {
                this.Invoke(new refleshUploadListDelegate(refleshUploadList), new object[] { toTopMost });
            }
            else
            {
                refleshUploadList(toTopMost);
            }
        }
        private void refleshUploadList(bool toTopMost)
        {
            listViewUpload.Items.Clear();
            UploadTaskInfo[] taskAry = UploadManager.getTaskAry();
            foreach (UploadTaskInfo task in taskAry)
            {
                String[] line = { 
                              task.fileName, 
                              task.user +" [" + task.serverInfo.name + "]", 
                              task.linktype, 
                              "",  
                              "",  
                              "" };
                ListViewItem item = new ListViewItem(line);
                item.Tag = task;
                listViewUpload.Items.Add(item);
            }
            if (toTopMost)
            {
                this.TopMost = true;
                this.TopMost = false;
            }
        }

        // アップロードリストヘッダ描画
        private void listViewUpload_DrawColumnHeader(object sender, DrawListViewColumnHeaderEventArgs e)
        {
            e.DrawDefault = true;
        }

        // アップロードリスト描画
        private void listViewUpload_DrawSubItem(object sender, DrawListViewSubItemEventArgs e)
        {
            if ((e.ItemState & ListViewItemStates.Selected) == ListViewItemStates.Selected)
            {
                e.Graphics.FillRectangle(SystemBrushes.Highlight, e.Bounds);
            }

            ListViewItem item = (ListViewItem)e.Item;
            //item.
            UploadTaskInfo task = (UploadTaskInfo)item.Tag;
            Brush statusBrush = null;
            switch (task.state)
            {
                case UploadTaskState.CANCELED:
                    statusBrush = taskBrushFail;
                    break;
                case UploadTaskState.WAIT:
                    statusBrush = taskBrushReady;
                    break;
                case UploadTaskState.UPLOADING:
                    statusBrush = taskBrushActive;
                    break;
                case UploadTaskState.COMPLETE:
                    statusBrush = taskBrushComp;
                    break;
                default:
                    statusBrush = taskBrushFail;
                    break;
            }
            if (e.Header.Text == COLNAME_UL1)
            {
                e.Graphics.DrawString(task.fileName, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_UL2)
            {
                e.Graphics.DrawString(task.user + " [" + task.serverInfo.name + "]", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_UL3) 
            {
                e.Graphics.DrawString(task.linktype, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_UL4)
            {
                //UL量更新
                String byteTxt = task.completeSize.ToString(AppCommon.FILE_SITE_FOMMAT) + " of " + task.fileSize.ToString();
                e.Graphics.DrawString(byteTxt, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
            }
            else if (e.Header.Text == COLNAME_UL5)
            {
                //速度更新
                if (task.ulSpeed != null)
                {
                    e.Graphics.DrawString(task.ulSpeed, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                }
            }
            else if (e.Header.Text == COLNAME_UL6)
            {
                switch (task.state)
                {
                    case UploadTaskState.CANCELED:
                        e.Graphics.DrawString("キャンセルしました", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        break;
                    case UploadTaskState.WAIT:
                        if (task.queueing)
                        {
                            e.Graphics.DrawString("他処理待機中", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        else
                        {
                            e.Graphics.DrawString("接続待ち", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                    case UploadTaskState.UPLOADING:
                        // プログレスバー             
                        int width = (int)(e.Bounds.Width * task.compPct);
                        Rectangle rect = new Rectangle(e.Bounds.X, e.Bounds.Y, width, e.Bounds.Height);
                        e.Graphics.FillRectangle(focusBrush, rect);
                        // 表記
                        if (task.compPctString != null)
                        {
                            e.Graphics.DrawString(task.compPctString, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                    case UploadTaskState.COMPLETE:
                        e.Graphics.DrawString("完了", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        break;
                    default: //UNKNOWN
                        if (task.errorString != null)
                        {
                            e.Graphics.DrawString(task.errorString, e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        else
                        {
                            e.Graphics.DrawString("不明なエラー", e.Item.Font, statusBrush, e.Bounds, consoleDrawFormat);
                        }
                        break;
                }

            }
            else
            {
                e.DrawText();
            }
        }


        // メッセージ追記
        delegate void writeConsoleMessageDelegate(String msg);
        private void writeConsoleMessageInvoke(String msg)
        {
            this.Invoke(new writeConsoleMessageDelegate(writeConsoleMessage), new object[] { msg });
        }
        private void writeConsoleMessage(String msg)
        {
            textBoxConsole.SelectionColor = AppCommon.setting.colorInfo.colorTime;
            String timeStr = DateTime.Now.ToString("HH:mm:ss") + " ";
            textBoxConsole.AppendText(System.Environment.NewLine);
            textBoxConsole.AppendText(timeStr);

            textBoxConsole.SelectionColor = AppCommon.setting.colorInfo.colorNormalMsg;
            int lockStartPos = textBoxConsole.Text.Length;
            textBoxConsole.SelectionStart = lockStartPos;
            textBoxConsole.AppendText(msg);
            textBoxConsole.Select(lockStartPos, textBoxConsole.Text.Length);
            textBoxConsole.SelectionProtected = true;

            if (textBoxConsole.Text.Length > AppCommon.PANEL_LOG_DOROP_LIMIT)
            {
                textBoxConsole.Select(0, AppCommon.PANEL_LOG_DOROP_STEP);
                textBoxConsole.SelectionProtected = false;
                textBoxConsole.SelectedText = "";
            }
            textBoxConsole.SelectionStart = textBoxConsole.Text.Length;
            textBoxConsole.ScrollToCaret();
        }

        // ダウンロードリスト 行描画更新
        delegate void releshDownloadItemDelegate(DownloadTaskInfo task);
        public void releshDownloadItemInvoke(DownloadTaskInfo task)
        {
            this.Invoke(new releshDownloadItemDelegate(releshDownloadItem), new object[] { task });
        }
        private void releshDownloadItem(DownloadTaskInfo task)
        {   
            for (int i = 0; i < listViewDownload.Items.Count; i++)
            {
                ListViewItem item = listViewDownload.Items[i];
                DownloadTaskInfo t = (DownloadTaskInfo)item.Tag;
                if (t.index == task.index)
                {
                    listViewDownload.RedrawItems(i, i, false);
                    break;
                }
            }
        }

        // アップロードリスト　行描画更新
        delegate void releshUploadItemDelegate(UploadTaskInfo task);
        public void releshUploadItemInvoke(UploadTaskInfo task)
        {
            this.Invoke(new releshUploadItemDelegate(releshUploadItem), new object[] { task });
        }
        private void releshUploadItem(UploadTaskInfo task)
        {
            for (int i = 0; i < listViewUpload.Items.Count; i++)
            {
                ListViewItem item = listViewUpload.Items[i];
                UploadTaskInfo t = (UploadTaskInfo)item.Tag;
                if (t.index == task.index)
                {
                    listViewUpload.RedrawItems(i, i, false);
                    break;
                }
            }
        }

        // ------------------------------------------------------------右クリ
        // ダウンロードリストダブルクリック
        private void listViewDownload_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                donwloadCtxViewItem = listViewDownload.GetItemAt(e.X, e.Y);
                if (donwloadCtxViewItem != null)
                {
                    DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                    if (donwloadCtxTask.state == DownloadTaskState.COMPLETE)
                    {
                        if (donwloadCtxTask.localTrueFilePath != null)
                        {
                            Process.Start(donwloadCtxTask.localTrueFilePath);
                            //Console.WriteLine("★" + donwloadCtxTask.localTrueFilePath);
                        }
                    }
                }
            }

        }

        // ダウンロードリスト右クリック
        private void listViewDownload_MouseClick(object sender, MouseEventArgs e)
        {
            donwloadCtxViewItem = null;
            menuItemDLCancel.Enabled = false;
            menuItemDLRetry.Enabled = false;
            menuItemDLAutoRetry.Enabled = false;
            menuItemDLRemoteQueue.Enabled = false;
            if (e.Button == MouseButtons.Right)
            {
                donwloadCtxViewItem = listViewDownload.GetItemAt(e.X, e.Y);
                if (donwloadCtxViewItem != null)
                {
                    ctxMenuDownLoadList.Show(MousePosition);
                    DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;

                    switch (donwloadCtxTask.state)
                    {
                        case DownloadTaskState.CANCELED:
                        case DownloadTaskState.DEAD:
                            menuItemDLRetry.Enabled = true;
                            menuItemDLAutoRetry.Enabled = true;
                            if (donwloadCtxTask.queueLimitFlg)
                            {
                                menuItemDLRemoteQueue.Enabled = true;
                            }
                            break;
                        case DownloadTaskState.WAIT:
                        case DownloadTaskState.REQUESTING:
                        case DownloadTaskState.DONWLOADING:
                            menuItemDLCancel.Enabled = true;
                            break;
                        case DownloadTaskState.COMPLETE:
                        default:
                            break;
                    }                    
                }
            }
        }

        // ダウンロードリスト：キャンセル
        private void menuItemDLCancel_Click(object sender, EventArgs e)
        {
            downloadCancel();
        }
        private void downloadCancel()
        {
            foreach (ListViewItem item in listViewDownload.SelectedItems)
            {
                DownloadTaskInfo task = (DownloadTaskInfo)item.Tag;
                switch (task.state)
                {
                    case DownloadTaskState.REQUESTING: 
                        task.cancel();
                        DownloadManager.startDownloadIfAble(true);//アクティブスレッドが居ないので自前
                        releshDownloadItem(task);
                        break;
                    case DownloadTaskState.WAIT:   // download開始してないから次スレ呼ばなくていい
                    case DownloadTaskState.DONWLOADING: // DLスレッドが次スレ呼ぶから放置
                        task.cancel();
                        releshDownloadItem(task);
                        break;
                    default:
                        break;
                }
            }
        }

        // ダウンロードリスト：クリア
        private void menuItemDLClear_Click(object sender, EventArgs e)
        {
            List<DownloadTaskInfo> removeList = new List<DownloadTaskInfo>();
            foreach (ListViewItem item in listViewDownload.SelectedItems)
            {
                removeList.Add((DownloadTaskInfo)item.Tag);
            }

            DownloadManager.removeDownloadTasks(removeList.ToArray(), true);
        }

        // ダウンロードリスト：ファイル削除
        private void menuItemDLDeleteFile_Click(object sender, EventArgs e)
        {
            foreach (ListViewItem item in listViewDownload.SelectedItems)
            {
                DownloadTaskInfo task = (DownloadTaskInfo)item.Tag;
                String targetFilePath = null;
                String targetFileName = null;
                if (File.Exists(task.localWorkFilePath))
                {
                    targetFilePath = task.localWorkFilePath;
                    targetFileName = task.localWorkFileName;
                } else if (File.Exists(task.localTrueFilePath))
                {
                    targetFilePath = task.localTrueFilePath;
                    targetFileName = task.localTrueFileName;
                }

                DialogResult result = MessageBox.Show(
                    "ファイル削除しますか？\n" + targetFileName,
                    "削除確認",
                    MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question,
                    MessageBoxDefaultButton.Button2);
                if (result == DialogResult.Yes)
                {
                    task.cancel();
                   // task.resourceClose();
                    try
                    {
                        File.Delete(targetFilePath);
                        FormTransfer.addConsoleMessage("削除しました：" + targetFileName);
                    }catch(Exception ex){
                        FormTransfer.addConsoleMessage("削除エラー：" + targetFileName + "\n" + ex.Message);
                    }
                }
            }
        }

        // ダウンロードリスト：リトライ
        private void menuItemDLRetry_Click(object sender, EventArgs e)
        {
            if (donwloadCtxViewItem != null) 
            {
                // 消して
                DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                DownloadManager.removeDownloadTasks(donwloadCtxTask, false);

                // 追加
                DownloadManager.addDownloadTask(donwloadCtxTask.serverInfo, donwloadCtxTask.searchResult);
            }
        }
        
        // 自動リトライ
        private void menuItemDLAutoRetry_Click(object sender, EventArgs e)
        {
            if (donwloadCtxViewItem != null)
            {
                // 消して
                DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                DownloadManager.removeDownloadTasks(donwloadCtxTask, false);

                // 追加
                DownloadManager.addDownloadTask(donwloadCtxTask.serverInfo, donwloadCtxTask.searchResult, false, true);
            }
        }

        // ダウンロードリスト：リモキュー
        private void menuItemDLRemoteQueue_Click(object sender, EventArgs e)
        {
            if (donwloadCtxViewItem != null)
            {
                // 消して
                DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                DownloadManager.removeDownloadTasks(donwloadCtxTask, false);

                // 追加
                DownloadManager.addDownloadTask(donwloadCtxTask.serverInfo, donwloadCtxTask.searchResult, true); //リモキューで登録
            }
        }

        // ダウンロードリスト：ユーザ情報
        private void tsMenuItemDownListUserInfo_Click(object sender, EventArgs e)
        {
            if (donwloadCtxViewItem != null)
            {
                DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                ServerManager.whoisC2Server(donwloadCtxTask.serverInfo, donwloadCtxTask.searchResult.nick);
            }
        }

        // ダウンロードリスト：ファイル一覧
        private void tsMenuItemDownloadListFileList_Click(object sender, EventArgs e)
        {
            if (donwloadCtxViewItem != null)
            {
                DownloadTaskInfo donwloadCtxTask = (DownloadTaskInfo)donwloadCtxViewItem.Tag;
                FormPersonalBrowse.startNew(donwloadCtxTask.serverInfo, donwloadCtxTask.searchResult.nick);
            }

        }

        // アップロードリスト右クリック
        private void listViewUpload_MouseClick(object sender, MouseEventArgs e)
        {
            //UploadTaskInfo
            uploadCtxViewItem = null;
            menuItemULCancel.Enabled = false;
            menuItemULClear.Enabled = false;
            if (e.Button == MouseButtons.Right)
            {
                uploadCtxViewItem = listViewUpload.GetItemAt(e.X, e.Y);
                if (uploadCtxViewItem != null)
                {
                    ctxMenuUploadList.Show(MousePosition);
                    UploadTaskInfo uploadCtxTask = (UploadTaskInfo)uploadCtxViewItem.Tag;

                    switch (uploadCtxTask.state)
                    {
                        case UploadTaskState.WAIT:
                        case UploadTaskState.UPLOADING:
                            menuItemULCancel.Enabled = true;
                            break;
                        case UploadTaskState.CANCELED:
                        case UploadTaskState.DEAD:
                        case UploadTaskState.COMPLETE:
                            menuItemULClear.Enabled = false;
                            break;
                        default:
                            break;
                    }
                }
            }

        }

        // アップロードリスト：キャンセル
        private void menuItemULCancel_Click(object sender, EventArgs e)
        {
            uploadCancel();
        }
        private void uploadCancel()
        {
            foreach (ListViewItem item in listViewUpload.SelectedItems)
            {
                UploadTaskInfo task = (UploadTaskInfo)item.Tag;
                switch (task.state)
                {
                    case UploadTaskState.WAIT:
                    case UploadTaskState.UPLOADING: // DLスレッドが次スレ呼ぶから放置
                        task.cancel();
                        releshUploadItem(task);
                        break;
                    default:
                        break;
                }
            }
        }

        // アップロードリスト：クリア
        private void menuItemULClear_Click(object sender, EventArgs e)
        {
            List<UploadTaskInfo> removeList = new List<UploadTaskInfo>();
            foreach (ListViewItem item in listViewUpload.SelectedItems)
            {
                removeList.Add((UploadTaskInfo)item.Tag);
            }

            UploadManager.removeUploadTasks(removeList.ToArray(), true);
        }

        // アップロードリスト：ユーザ情報
        private void tsMenuItemUploadListUserInfo_Click(object sender, EventArgs e)
        {
            if (uploadCtxViewItem != null)
            {
                UploadTaskInfo uploadCtxTask = (UploadTaskInfo)uploadCtxViewItem.Tag;
                ServerManager.whoisC2Server(uploadCtxTask.serverInfo, uploadCtxTask.user);
            }
        }

        // アップロードリスト：ファイル一覧
        private void tsMenuItemUploadListFileList_Click(object sender, EventArgs e)
        {
            if (uploadCtxViewItem != null)
            {
                UploadTaskInfo uploadCtxTask = (UploadTaskInfo)uploadCtxViewItem.Tag;
                FormPersonalBrowse.startNew(uploadCtxTask.serverInfo, uploadCtxTask.user);
            }
        }


        // ------------------------------------------------------------ボタン

        // ダウンロードリスト：フォルダ開く
        private void menuItemDLOpenDir_Click(object sender, EventArgs e)
        {
            openFolder();
        }

        // ダウンロード　ボタン：フォルダ開く
        private void buttonTab1OpenDir_Click(object sender, EventArgs e)
        {
            openFolder();
        }

        private void openFolder()
        {
            try            
            {
                Process.Start(AppCommon.setting.downloadFolder);
            }
            catch (Exception e)
            {
                writeConsoleMessage("フォルダオープンに失敗:" + e.Message);
            }
        }

        // ダウンロード　ボタン：キャンセル
        private void buttonTab1Cancel_Click(object sender, EventArgs e)
        {
            downloadCancel();
        }

        // ダウンロード　ボタン：完消し
        private void buttonTab1DelComp_Click(object sender, EventArgs e)
        {
            List<DownloadTaskInfo> removeDownloadTaskInfoList = new List<DownloadTaskInfo>();
            foreach (ListViewItem item in listViewDownload.Items)
            {
                DownloadTaskInfo task = (DownloadTaskInfo)item.Tag;
                if (task.state == DownloadTaskState.COMPLETE)
                {
                    removeDownloadTaskInfoList.Add(task);
                }
            }

            DownloadManager.removeDownloadTasks(removeDownloadTaskInfoList.ToArray(), true);
        }

        // ダウンロード　ボタン：未完消し
        private void buttonTab1DelIncomp_Click(object sender, EventArgs e)
        {
            List<DownloadTaskInfo> removeDownloadTaskInfoList = new List<DownloadTaskInfo>();
            foreach (ListViewItem item in listViewDownload.Items)
            {
                DownloadTaskInfo task = (DownloadTaskInfo)item.Tag;
                if (task.state == DownloadTaskState.DEAD || task.state == DownloadTaskState.CANCELED)
                {
                    removeDownloadTaskInfoList.Add(task);
                }
            }
            DownloadManager.removeDownloadTasks(removeDownloadTaskInfoList.ToArray(), true);
        }

        // アップロード　ボタン：キャンセル
        private void buttonTab2Cancel_Click(object sender, EventArgs e)
        {
            uploadCancel();
        }

        // アップロード　ボタン：完了削除
        private void buttonTab2DelComp_Click(object sender, EventArgs e)
        {
            List<UploadTaskInfo> removeUploadTaskInfoList = new List<UploadTaskInfo>();
            foreach (ListViewItem item in listViewUpload.Items)
            {
                UploadTaskInfo task = (UploadTaskInfo)item.Tag;
                if (task.state == UploadTaskState.COMPLETE)
                {
                    removeUploadTaskInfoList.Add(task);
                }
            }
            UploadManager.removeUploadTasks(removeUploadTaskInfoList.ToArray(), true);
        }

        // アップロード　ボタン：未完消し
        private void buttonTab2DelIncomp_Click(object sender, EventArgs e)
        {
            List<UploadTaskInfo> removeUploadTaskInfoList = new List<UploadTaskInfo>();
            foreach (ListViewItem item in listViewUpload.Items)
            {
                UploadTaskInfo task = (UploadTaskInfo)item.Tag;
                if (task.state == UploadTaskState.DEAD || task.state == UploadTaskState.CANCELED)
                {
                    removeUploadTaskInfoList.Add(task);
                }
            }
            UploadManager.removeUploadTasks(removeUploadTaskInfoList.ToArray(), true);
        }

        // フォーム移動
        private void FormTransfer_Move(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Normal && AppCommon.setting.saveWindowPos)
            {
                AppCommon.setting.transWindowPosX = this.Location.X;
                AppCommon.setting.transWindowPosY = this.Location.Y;
                AppCommon.save();
            }
        }

        // フォームリサイズ
        private void FormTransfer_ResizeEnd(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Normal && AppCommon.setting.saveWindowPos)
            {
                AppCommon.setting.transWindowWidth = this.Width;
                AppCommon.setting.transWindowHeight = this.Height;
                AppCommon.save();
            }
        }

        // アップロードリストカラム変更
        private void listViewUpload_ColumnWidthChanged(object sender, ColumnWidthChangedEventArgs e)
        {
            if (AppCommon.setting.saveWindowPos)
            {
                foreach (ColumnHeader col in listViewUpload.Columns)
                {
                    switch (col.Text)
                    {
                        case COLNAME_UL1:
                            AppCommon.setting.ulListColWidthulFile = col.Width;
                            break;
                        case COLNAME_UL2:
                            AppCommon.setting.ulListColWidthulUser = col.Width;
                            break;
                        case COLNAME_UL3:
                            AppCommon.setting.ulListColWidthulSpeed = col.Width;
                            break;
                        case COLNAME_UL4:
                            AppCommon.setting.ulListColWidthulBytes = col.Width;
                            break;
                        case COLNAME_UL5:
                            AppCommon.setting.ulListColWidthulks = col.Width;
                            break;
                        case COLNAME_UL6:
                            AppCommon.setting.ulListColWidthulStatus = col.Width;
                            break;
                        default:
                            Console.WriteLine("不明なカラム：" + col.Text + "/" + col.Width + "");
                            break;
                    }
                }
                AppCommon.save();
            }
        }

        // ダウンロードリストカラム幅変更
        private void listViewDownload_ColumnWidthChanged(object sender, ColumnWidthChangedEventArgs e)
        {
            
            if (AppCommon.setting.saveWindowPos)
            {
                foreach (ColumnHeader col in listViewDownload.Columns)
                {
                    switch (col.Text)
                    {
                        case COLNAME_DL1:
                            AppCommon.setting.dlListColWidthdlFile = col.Width;
                            break;
                        case COLNAME_DL2:
                            AppCommon.setting.dlListColWidthdlUser = col.Width;
                            break;
                        case COLNAME_DL3:
                            AppCommon.setting.dlListColWidthdlSpeed = col.Width;
                            break;
                        case COLNAME_DL4:
                            AppCommon.setting.dlListColWidthdlBytes = col.Width;
                            break;
                        case COLNAME_DL5:
                            AppCommon.setting.dlListColWidthdlks = col.Width;
                            break;
                        case COLNAME_DL6:
                            AppCommon.setting.dlListColWidthdlStatus = col.Width;
                            break;
                        default:
                            Console.WriteLine("不明なカラム：" + col.Text + "/" + col.Width + "");
                            break;
                    }
                }
                AppCommon.save();
            }
        }



    }
}

//delegate void **Delegate(ServerInfo serverInfo);
//public void **Invoke(ServerInfo serverInfo)
//{
//    if (InvokeRequired)
//    {
//        this.Invoke(new **Delegate(**), new object[] { serverInfo });
//    } else {
//        **(serverInfo);
//    }
//}
//private void **(ServerInfo serverInfo)
//{
//}